<template>
    <div>
        <div class="loading" v-if="loading">
            <p id="loadd">LOADING...</p>
        </div>
        <input type="text" id="filtre" v-on:keyup="filtre()"/>
        <div class="container" id="contingut">
            <div class="card fitxarManual">
                <div class="card-header">Fitxar</div>
                <div class="card-body">
                    <table id="tableTreballadors">
                        <tr>
                            <th class="campF"><b>Nom</b></th>
                            <th class="campF"><b>Fitxar</b></th>
                        </tr>
                        <tr v-for="treballador in treballadors" v-bind:key="treballador.id">
                            <td class="campF" v-text="treballador.nom"></td>
                            <td class="campF">
                                <button :id="treballador.id" class="btn btn-primary" v-on:click="fitxar(treballador.id)">
                                    <span class="glyphicon glyphicon-ok"></span>
                                </button>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
            <div class="card mostraDades">
                <div class="card-header">Dades del treballador/a</div>
                <div class="card-body">
                    <div class="dada" id="primer">
                        <b>Nom del treballador/a: </b>
                        <span id="nomTreballador"></span>
                    </div>
                    <div class="dada">
                        <b>Data: </b>
                        <span id="dataFitxar"></span>
                    </div>
                    <div class="dada">
                        <b>Hora: </b>
                        <span id="horaFitxar">None</span>
                    </div>
                    <div class="dada" id="btn">
                        <button class="btn btn-a" id="btn-arrow" disabled type="submit" v-on:click="fitxar(treballador.id)">
                            <span class="glyphicon" id="icon"></span>
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    props: ["user", "ruta", "dataH"],
    mounted() {
        console.log("Component mounted.");
    },
    data: function() {
        return {
            usuari: [],
            treballadors: [],
            treballador: [],
            fitxa: [],
            entrada: null,
            dataR: null,
            dates: [],
            dataE: null,
            horaR: null,
            loading: false,
            clientCentre: null
        }
    },
    methods: {
        filtre(){
            var input, filter, table, tr, td, i, txtValue;
            input = document.getElementById("filtre");
            filter = input.value.toUpperCase();
            table = document.getElementById("tableTreballadors");
            tr = table.getElementsByTagName("tr");
            for (i = 0; i < tr.length; i++) {
                td = tr[i].getElementsByTagName("td")[0];
                if (td) {
                    txtValue = td.textContent || td.innerText;
                    if (txtValue.toUpperCase().indexOf(filter) > -1) {
                        tr[i].style.display = "";
                    } else {
                        tr[i].style.display = "none";
                    }
                }       
            }
        },
        fitxar($treballador_id){
            this.loading = true;
            var dataFitxar = document.getElementById('dataFitxar');
            var horaFitxar = document.getElementById('horaFitxar');
            var nomTreballador = document.getElementById('nomTreballador');
            var btn = document.getElementById("btn-arrow");
            var spa = document.getElementById("icon");
            var btnU = document.getElementById($treballador_id);
            btnU.classList.remove("btn-primary");
            btnU.classList.add("btn-success");
            axios
            .get(this.ruta + '/api/obtenirData')
            .then(response => {
                this.dates = response.data;
                this.horaR = this.dates[0];
                this.dataR = this.dates[1];
                this.dataE = this.dates[2];
                this.formatData();
                axios
                .get(this.ruta + '/api/entradaosortida/' + $treballador_id)
                .then(response => {
                    this.fitxa = response.data;
                    if(this.fitxa.length == 0){
                        this.entrada = 0;
                        btn.classList.add("btn-success");
                        spa.classList.add("glyphicon-chevron-left");
                        btnU.classList.remove("btn-primary");
                        btnU.classList.add("btn-success");
                    }else{
                        this.entrada = this.fitxa[this.fitxa.length - 1].entradasortida;
                        if(this.entrada == 0){
                            this.entrada = 1;
                            btn.classList.remove("btn-success");
                            btn.classList.add("btn-danger");
                            spa.classList.remove("glyphicon-chevron-left");
                            spa.classList.add("glyphicon-chevron-right");
                        }else{
                            this.entrada = 0;
                            btn.classList.remove("btn-danger");
                            btn.classList.add("btn-success");
                            spa.classList.remove("glyphicon-chevron-right")
                            spa.classList.add("glyphicon-chevron-left");
                        }
                    }

                    axios
                    .get(this.ruta + '/api/treballadorById/' + $treballador_id)
                    .then(response => {
                        this.treballador = response.data;
                        nomTreballador.textContent = this.treballador[0].nom;
                        dataFitxar.textContent = this.dataR;
                        horaFitxar.textContent = this.horaR;
                        
                         axios
                        .get(this.ruta + '/api/obtenircentreclient/' + this.user)
                        .then(response => {
                            this.clientCentre = response.data;
                            axios
                            .post(this.ruta + "/api/registre", {
                                treballador_id: $treballador_id,
                                dataRegistre: this.dataE,
                                horaRegistre: this.horaR,
                                entradasortida: this.entrada,
                                client_id: this.clientCentre.client_id,
                                centre_id: this.clientCentre.centre_id

                            }).finally(() => (this.loading = false));
                        });
                    });         
                });
            });
        },
        formatData(){
            var dataRR = this.dataR.split("/");
            if(dataRR[0] < 10){
                dataRR[0] = "0" + dataRR[0];
            }
            if(dataRR[1] < 10){
                dataRR[1] = "0" + dataRR[1];
            }
            if(dataRR[2] < 10){
                dataRR[2] = "0" + dataRR[2];
            }
            this.dataR = dataRR[0] + "/" + dataRR[1] + "/" + dataRR[2];
            var dataEE = this.dataE.split("-");
            if(dataEE[1] < 10){
                dataEE[1] = "0" + dataEE[1];
            }
            if(dataEE[2] < 10){
                dataEE[2] = "0" + dataEE[2];
            }
            this.dataE = dataEE[0] + "-" + dataEE[1] + "-" + dataEE[2];
            var horaRR = this.horaR.split(":");
            if(horaRR[0] < 10){
                horaRR[0] = "0" + horaRR[0];
            }
            if(horaRR[1] < 10){
                horaRR[1] = "0" + horaRR[1];
            }
            if(horaRR[2] < 10){
                horaRR[2] = "0" + horaRR[2];
            }
            this.horaR = horaRR[0] + ":" + horaRR[1] + ":" + horaRR[2];
        }
    },
    mounted: function() {
        console.log("Component mounted.");
        axios
        .get(this.ruta + '/api/treballadors')
        .then(response => {
            this.treballadors = response.data;
        });
    }
}
</script>
